package com.iformall.service;

import java.util.Date;
import java.util.List;

import com.github.pagehelper.PageInfo;
import com.iformall.domain.po.WxCUser;
import com.iformall.domain.po.WxCUserBasicInfo;
import com.iformall.domain.po.WxCUserTags;
import com.iformall.domain.po.WxTags;
import com.iformall.enums.EnumAssignTagsTrigger;

public interface WxCUserTagsService {

	/**
     * 根据实体查询分页列表
     *
     * @param record
     * @param offset
     * @param limit
     * @return
     */
	PageInfo<WxCUserTags> listAsPage(WxCUserTags record, Integer pageIndex, Integer pageSize);
	
	/**
     * 根据Id获得实体
     *
     * @param id
     * @return
     */
    WxCUserTags getById(Long id);
    
        /**
     * 保存或更新实体
     *
     * @param record
     */
    void saveOrUpdate(WxCUserTags record);

    /**
     * 根据Id删除实体
     *
     * @param id
     */
    void deleteById(Long id);
    

	/**
	 *
	 * tagIds查询用户user信息集合(会员列表中的user)
	 * @param tagIds
	 * @return
	 */
	List<WxCUserBasicInfo> findByTag(String tenantId, List<Long> tagIds);

	/**
     * 
     * tagIds查询用户user信息集合(登陆过C端的用户,并且保有手机号)
     * @param tagIds
     * @return
     */
	List<WxCUser> findCUserByTag(String tenantId, List<Long> tagIds);


	long countUser(String tenantId, Long tagId, Date startTime, Date endTime );

	List<WxTags> findTagList(String tenantId, List<Long> tagIds);
	List<WxTags> findTagListFromCUser(String tenantId, List<Long> tagIds);

	List<WxTags> assignTags(List<Long> tagIdList, WxCUserBasicInfo user);
	List<WxTags> triggerAssignTags(EnumAssignTagsTrigger trigger, Object obj);

}
